/*
 * Copyright (c) 2008 The_xmloperator_project.  All rights reserved.
 * See terms of use on the project's site (http://www.xmloperator.net/reactive/).
 */
package org.xmloperator.reactive.element;

import org.xmloperator.reactive.exception.PrivilegiedAccessException;

/**
 * Element writing access.
 */
public interface ElementWritingAccess {
	
    /**
     * Returns a read-write access to a given Element.
     * @param element an Element.
     * @param writingKey the key that allows to write elements.
     * @return a read-write access to a given Element.
     * @exception PrivilegiedAccessException if the given key is not the good one.
     */
    public RWElement rwElement(Element element, long writingKey)
    	throws PrivilegiedAccessException;
}
