/*
 * Copyright (c) 2008 The_xmloperator_project.  All rights reserved.
 * See terms of use on the project's site (http://www.xmloperator.net/reactive/).
 */
package org.xmloperator.reactive.element.action;

import org.xmloperator.reactive.Action;

//import org.xmloperator.reactive.element.Element;
import org.xmloperator.reactive.element.ParentElement;
import org.xmloperator.reactive.element.RWParentElement;
import org.xmloperator.reactive.element.ElementWritingAccess;

import org.xmloperator.reactive.element.action.ElementActionImpl;

/**
 * Action of removing all children of a ParentElement.
 */
public final class ChildrenRemoveAction extends ElementActionImpl {
	
	public ChildrenRemoveAction(ElementWritingAccess elementWritingAccess,
			ParentElement referenceElement, int status) {
		super(elementWritingAccess, referenceElement, status);
	}
	
	public boolean isChildrenRemoveAction() {
		return true;
	}

	///////////////////////////////
	// ElementAction implementation
	///////////////////////////////
	
	public ParentElement getTouchedParentElement() {
		return (ParentElement)this.referenceElement;
	}
	
	////////////////////////
	// Action implementation
	////////////////////////
	
	public boolean equals(Action action) {
		if (!(action instanceof ChildrenRemoveAction))
			return false;
		ChildrenRemoveAction otherAction = (ChildrenRemoveAction)action;
		return this.referenceElement == otherAction.referenceElement;
	}

	public void execute(long key) {
		RWParentElement rwParentElement =
			(RWParentElement)this.elementWritingAccess.rwElement(
				this.referenceElement, key);
		rwParentElement.removeChildren();
	}
	////////////////////////
	// Object implementation
	////////////////////////
	
	public String toString() {
		StringBuffer sb = new StringBuffer();
		sb.append(super.toString());
		sb.append("removeChildren");
		return sb.toString();
	}
}
