/*
 * Copyright (c) 2008 The_xmloperator_project.  All rights reserved.
 * See terms of use on the project's site (http://www.xmloperator.net/reactive/).
 */
package org.xmloperator.reactive.element.spec;

import org.xmloperator.reactive.element.Element;
import org.xmloperator.reactive.element.ParentElement;

import org.xmloperator.reactive.element.impl.ParentElementImpl;

/**
 * ElementSpecification of the root Element.
 */
public final class RootElementSpecification
		implements ElementSpecification {
	
	public static final RootElementSpecification ROOT =
		new RootElementSpecification();
	
	private RootElementSpecification() {
	}
	
	//////////////////////////////////////
	// ElementSpecification implementation
	//////////////////////////////////////
	
	public boolean accepts(Element element) {
		return element.getParent() == null;
	}
	
	////////////////////////////////////
	// TranslatableObject implementation
	////////////////////////////////////

	public ParentElement translate() {
		return new ParentElementImpl(Element.REACTIVE_NAMESPACE, "root");
	}

	public Class getRebuilderClass() {
		return RootElementSpecRebuilder.class;
	}
}
