/*
 * Copyright (c) 2008 The_xmloperator_project.  All rights reserved.
 * See terms of use on the project's site (http://www.xmloperator.net/reactive/).
 */
package org.xmloperator.reactive.facet;

import java.io.PrintStream;

import org.xmloperator.reactive.exception.ReactiveException;

import org.xmloperator.reactive.Agent;
import org.xmloperator.reactive.TermsAttachment;
import org.xmloperator.reactive.ActionAttachment;
import org.xmloperator.reactive.Event;
import org.xmloperator.reactive.LaunchingContext;
import org.xmloperator.reactive.Message;
import org.xmloperator.reactive.ReactiveEntity;

/**
 * Agent implementation.
 */
public abstract class FacetImpl implements Facet {

	protected Agent agent = null;
	protected LaunchingContext launchingContext = null;
	protected ReactiveEntity reac = null;
	protected PrintStream trace = null;
	
	public FacetImpl() {
	}
	
	public void attach(Agent agent) {
		boolean ok;
		synchronized (this) {
			ok = this.agent == null;
			if (ok)
				this.agent = agent;
		}
		if (!ok)
			throw new ReactiveException("Busy Facet");
	}
	

	///////////////////////
	// Facet implementation
	///////////////////////
	
	public Agent getAgent() {
		return this.agent;
	}
	
	public Object getService() {
		return null;
	}
	
	public void init(LaunchingContext launchingContext) {
		this.launchingContext = launchingContext;
		this.reac = (ReactiveEntity)launchingContext.getArgumentValue(
				Agent.ARG_REACTIVE_ENTITY);
		this.trace = (PrintStream)launchingContext.getArgumentValue(
				Agent.ARG_TRACE_PRINT_STREAM);
	}

	public void startOfInstant() {
	}
	
	public int getEmptyInstantMinDuration_ms() {
		return ReactiveEntity.AN_EVENT_AT_ANY_TIME;
	}
	
	public boolean processEvent(Event event) {
		return false;
	}

	public boolean processServiceMessage(String message,
			TermsAttachment terms) {
		return false;
	}

	public void processServiceExcludedMessage(Message message,
			TermsAttachment terms) {
	}
	
	public void processActionMessage(
			Message message, ActionAttachment attachment) {
	}
	
	public void terminate() {
	}
}
