/*
 * Copyright (c) 2008 The_xmloperator_project.  All rights reserved.
 * See terms of use on the project's site (http://www.xmloperator.net/reactive/).
 */
package org.xmloperator.reactive.facet.event;

import org.xmloperator.reactive.Event;

/**
 * BoolCondition corresponding to a given base Event occuring or not occuring.
 */
public abstract class EventBoolConditionImpl extends BoolConditionImpl {
	
	protected final Event event;
	
	public EventBoolConditionImpl(Event event) {
		if (event == null || !event.isBaseEvent())
			throw new IllegalArgumentException();
		this.event = event;
	}
	
	//////////////////////////
	// BoolNode implementation
	//////////////////////////
	
	public Event getBaseEvent() {
		return this.event;
	}
}
