/*
 * Copyright (c) 2008 The_xmloperator_project.  All rights reserved.
 * See terms of use on the project's site (http://www.xmloperator.net/reactive/).
 */
package org.xmloperator.reactive.impl;

import org.xmloperator.reactive.Action;
import org.xmloperator.reactive.ActionAttachment;

/**
 * ActionAttachment implementation.
 */
final class ActionAttachmentImpl extends CertifiedAttachmentImpl
		implements ActionAttachment {
	
	private final Action action;
	private Exception exception = null;
	
	ActionAttachmentImpl(Action action) {
		this.action = action;
	}
	
	void setException(Exception exception) {
		this.exception = exception;
	}
	
	//////////////////////////////////
	// ActionAttachment implementation
	//////////////////////////////////
	
	public Action getAction() {
		return this.action;
	}

	public Exception getException() {
		return this.exception;
	}

	/////////////////////////////////////
	// CertifiedAttachment implementation
	/////////////////////////////////////
	
	public boolean isActionAttachment() {
		return true;
	}
	
	////////////////////////
	// Object implementation
	////////////////////////
	
	public String toString() {
		StringBuffer sb = new StringBuffer();
		sb.append(super.toString());
		sb.append('(');
		sb.append(this.action);
		if (this.exception != null) {
			sb.append(',');
			sb.append(exception);
		}
		sb.append(')');
		return sb.toString();
	}
}
